---
title: max-block-size
slug: Web/CSS/max-block-size
tags:
  - CSS
  - CSS Logical Property
  - CSS Property
  - Experimental
  - Layout
  - Maximum Height
  - Maximum Width
  - Reference
  - height
  - max-block-size
  - 'recipe:css-property'
  - size
  - width
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <code><strong>max-block-size</strong></code> <a href="/en-US/docs/Web/CSS">CSS</a> property specifies the maximum size of an element in the direction opposite that of the writing direction as specified by {{cssxref("writing-mode")}}.</span> That is, if the writing direction is horizontal, then <code>max-block-size</code> is equivalent to {{cssxref("max-height")}}; if the writing direction is vertical, <code>max-block-size</code> is the same as {{cssxref("max-width")}}.</p>

<p>The other dimension's maximum length is specified using the {{cssxref("max-inline-size")}} property.</p>

<p>This is useful because the <code>max-width</code> is always used for horizontal sizes and <code>max-height</code> is always used for vertical sizes, and if you need to set lengths based on the size of your text content, you need to be able to do so with the writing direction in mind.</p>

<p>Any time you would normally use <code>max-height</code> or <code>max-width</code>, you should instead use <code>max-block-size</code> to set the maximum "height" of the content (even though this may not be a vertical value) and <code>max-inline-size</code> to set the maximum "width" of the content (although this may instead be vertical rather than horizontal). See the {{SectionOnPage("/en-US/docs/Web/CSS/writing-mode", "Example")}}, which shows the different writing modes in action.</p>

<div>{{EmbedInteractiveExample("pages/css/max-block-size.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* &lt;length&gt; values */
max-block-size: 300px;
max-block-size: 25em;

/* &lt;percentage&gt; values */
max-block-size: 75%;

/* Keyword values */
max-block-size: auto;
max-block-size: max-content;
max-block-size: min-content;
max-block-size: fit-content(20em);

/* Global values */
max-block-size: inherit;
max-block-size: initial;
max-block-size: unset;
</pre>

<h3 id="Values">Values</h3>

<p>The <code>max-block-size</code> property's value can be any value that's legal for the {{cssxref("max-width")}} and {{cssxref("max-height")}} properties:</p>

<p>{{page("/en-US/docs/Web/CSS/max-width", "Values")}}</p>

<h3 id="How_writing-mode_affects_directionality">How writing-mode affects directionality</h3>

<p>The values of <code>writing-mode</code> affect the mapping of <code>max-block-size</code> to <code>max-width</code> or <code>max-height</code> as follows:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Values of <code>writing-mode</code></th>
   <th scope="col"><code>max-block-size</code> is equivalent to</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>horizontal-tb</code>, <code>lr</code> {{deprecated_inline}}, <code>lr-tb</code> {{deprecated_inline}}, <code>rl</code> {{deprecated_inline}}, <code>rb</code> {{deprecated_inline}}, <code>rb-rl</code> {{deprecated_inline}}</td>
   <td>{{cssxref("max-height")}}</td>
  </tr>
  <tr>
   <td><code>vertical-rl</code>, <code>vertical-lr</code>, <code>sideways-rl</code> {{experimental_inline}}, <code>sideways-lr</code> {{experimental_inline}}, <code>tb</code> {{deprecated_inline}}, <code>tb-rl</code> {{deprecated_inline}}</td>
   <td>{{cssxref("max-width")}}</td>
  </tr>
 </tbody>
</table>

<div class="note">
<p>The <code>writing-mode</code> values <code>sideways-lr</code> and <code>sideways-rl</code> were removed from the CSS Writing Modes Level 3 specification late in its design process. They may be restored in Level 4.</p>
</div>

<div class="note">
<p>The writing modes <code>lr</code>, <code>lr-tb</code>, <code>rl</code>, <code>rb</code>, and <code>rb-tl</code> are no longer allowed in {{Glossary("HTML")}} contexts; they may only be used in {{Glossary("SVG")}} 1.x contexts.</p>
</div>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_max-block-size_with_horizontal_and_vertical_text">Setting max-block-size with horizontal and vertical text</h3>

<p>In this example, the same text (the opening sentences from {{interwiki("wikipedia", "Herman Melville", "Herman Melville's")}} novel <em>{{interwiki("wikipedia", "Moby-Dick")}}</em>) is presented in both the <code>horizontal-tb</code> and <code>vertical-rl</code> writing modes.</p>

<p>Everything else about the two boxes is identical, including the values used for {{cssxref("max-block-size")}}.</p>

<h4 id="HTML">HTML</h4>

<p>The HTML establishes the two {{HTMLElement("div")}} blocks that will be presented with their {{cssxref("writing-mode")}} set using the classes <code>horizontal</code> or <code>vertical</code>. Both boxes share the <code>standard-box</code> class, which establishes coloring, padding, and their respective values of <code>max-block-size</code>.</p>

<pre class="brush: html notranslate">&lt;p&gt;Writing mode &lt;code&gt;horizontal-tb&lt;/code&gt; (the default):&lt;/p&gt;
&lt;div class="standard-box horizontal"&gt;
  Call me Ishmael. Some years ago—never mind how
  long precisely—having little or no money in my
  purse, and nothing particular to interest me on
  shore, I thought I would sail about a little and see
  the watery part of the world. It is a way I have of
  driving off the spleen and regulating the
  circulation.
&lt;/div&gt;

&lt;p&gt;Writing mode &lt;code&gt;vertical-rl&lt;/code&gt;:&lt;/p&gt;
&lt;div class="standard-box vertical"&gt;
  Call me Ishmael. Some years ago—never mind how
  long precisely—having little or no money in my
  purse, and nothing particular to interest me on
  shore, I thought I would sail about a little and see
  the watery part of the world. It is a way I have of
  driving off the spleen and regulating the
  circulation.
&lt;/div&gt;</pre>

<h4 id="CSS">CSS</h4>

<p>The CSS defines three classes. The first, <code>standard-box</code>, is applied to both boxes, as seen above. It provides standard styling including the minimum and maximum block sizes, font size, and so forth.</p>

<p>After that come the classes <code>horizontal</code> and <code>vertical</code>, which add the {{cssxref("writing-mode")}} property to the box, with the value set to <code>horizontal-tb</code> or <code>vertical-rl</code> depending on which class is used.</p>

<pre class="brush: css notranslate">.standard-box {
  padding: 4px;
  background-color: #abcdef;
  color: #000;
  font: 16px "Open Sans", "Helvetica", "Arial", sans-serif;
  max-block-size: 160px;
  min-block-size: 100px;
}

.horizontal {
  writing-mode: horizontal-tb;
}

.vertical {
  writing-mode: vertical-rl;
}
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Setting_max-block-size_with_horizontal_and_vertical_text", 600, 850)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS Logical Properties", "#propdef-max-block-size", "max-block-size")}}</td>
   <td>{{Spec2("CSS Logical Properties")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.max-block-size")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The mapped physical properties: {{cssxref("max-width")}} and {{cssxref("max-height")}}</li>
 <li>Setting the other direction's maximum size: {{cssxref("max-inline-size")}}</li>
 <li>{{cssxref("writing-mode")}}</li>
</ul>
